org.jboss.resteasy.security.smime

## Class PKCS7SignatureWriter

- java.lang.Object
- - org.jboss.resteasy.security.smime.PKCS7SignatureWriter

- All Implemented Interfaces:
    MessageBodyWriter<SignedOutput>

      @Provider
      @Produces(value="application/pkcs7-signature")
      public class PKCS7SignatureWriter
      extends Object
      implements MessageBodyWriter<SignedOutput>

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Providers` | `providers`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PKCS7SignatureWriter()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `getSize(SignedOutput smimeOutput, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Originally, the method has been called before `writeTo` to ascertain the length in bytes of the serialized form of `t`.
    `boolean` | `isWriteable(Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyWriter supports a particular type.
    `static byte[]` | `sign(Providers providers, SignedOutput out)`
    `void` | `writeTo(SignedOutput out, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,Object> headers, OutputStream os)` Write a type to an HTTP message.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### providers

          @Context
          protected Providers providers

  - ### Constructor Detail

    - #### PKCS7SignatureWriter

          public PKCS7SignatureWriter()

  - ### Method Detail

    - #### isWriteable

          public boolean isWriteable(Class<?> type,
                            Type genericType,
                            Annotation[] annotations,
                            MediaType mediaType)

      Description copied from interface: `MessageBodyWriter`
      Ascertain if the MessageBodyWriter supports a particular type.
      Specified by:
        `isWriteable` in interface `MessageBodyWriter<SignedOutput>`
      Parameters:
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written, obtained either by reflection of a resource method return type or via inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
      Returns:
        `true` if the type is supported, otherwise `false`.

    - #### getSize

          public long getSize(SignedOutput smimeOutput,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType)

      Description copied from interface: `MessageBodyWriter`
      Originally, the method has been called before `writeTo` to ascertain the length in bytes of the serialized form of `t`. A non-negative return value has been used in a HTTP `Content-Length` header.

      As of JAX-RS 2.0, the method has been deprecated and the value returned by the method is ignored by a JAX-RS runtime. All `MessageBodyWriter` implementations are advised to return `-1` from the method. Responsibility to compute the actual `Content-Length` header value has been delegated to JAX-RS runtime.

      Specified by:
        `getSize` in interface `MessageBodyWriter<SignedOutput>`
      Parameters:
        `smimeOutput` - the instance to write
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
      Returns:
        length in bytes or -1 if the length cannot be determined in advance.

    - #### writeTo

          public void writeTo(SignedOutput out,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType,
                     MultivaluedMap<String,Object> headers,
                     OutputStream os)
                       throws IOException,
                              WebApplicationException

      Description copied from interface: `MessageBodyWriter`
      Write a type to an HTTP message. The message header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the message body.
      Specified by:
        `writeTo` in interface `MessageBodyWriter<SignedOutput>`
      Parameters:
        `out` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `headers` - a mutable map of the HTTP message headers.
        `os` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
      Throws:
        `IOException` - if an IO error arises.
        `WebApplicationException` - if a specific HTTP error response needs to be produced. Only effective if thrown prior to the message being committed.

    - #### sign

          public static byte[] sign(Providers providers,
                    SignedOutput out)
                             throws IOException,
                                    NoSuchAlgorithmException,
                                    NoSuchProviderException,
                                    org.bouncycastle.cms.CMSException

      Throws:
        `IOException`
        `NoSuchAlgorithmException`
        `NoSuchProviderException`
        `org.bouncycastle.cms.CMSException`

Copyright © 2014. All Rights Reserved.